diff --git a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
index 3ab1e68cb..4019bc1a4 100644
--- a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
+++ b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
@@ -22,6 +22,9 @@ public class GuiPaged
     private static final int PADDING = 8;
     private static final int PAGE_BUTTON_HEIGHT = 20;
 
+    private final String titleTranslationKey;
+    private final String[] buttonTranslationKeys;
+
     private float rightScrollAmount = 0.0f;
     private float leftScrollAmount = 0.0f;
     private int top, bottom, rightScrollRegionHeight, leftScrollRegionHeight, pageWidth, leftWidth;
@@ -36,11 +39,13 @@ public class GuiPaged
 
     private final PageRegistry pageRegistry;
 
-    public GuiPaged(GuiScreen parent, PageRegistry pageRegistry, Page selectedPage)
+    public GuiPaged(GuiScreen parent, PageRegistry pageRegistry, Page selectedPage, String titleTranslationKey, String[] buttonTranslationKeys)
     {
         super(parent);
         this.pageRegistry = pageRegistry;
         this.selectedPage = selectedPage;
+        this.titleTranslationKey = titleTranslationKey;
+        this.buttonTranslationKeys = buttonTranslationKeys;
     }
 
     @Override
@@ -48,7 +53,12 @@ public class GuiPaged
     {
         super.init();
 
-        controlList.add(new GuiButton(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")));
+        int buttonWidth = 200 - (buttonTranslationKeys.length - 1) * 40;
+        int totalButtonsWidth = buttonTranslationKeys.length * (buttonWidth + 4) - 4;
+        for (int i = 0; i < buttonTranslationKeys.length; i++) {
+            String buttonTranslationKey = buttonTranslationKeys[i];
+            controlList.add(new GuiButton(i, width / 2 - totalButtonsWidth / 2 + ((buttonWidth + 4) * i), height - (BUTTON_SPACING + 20), buttonWidth, 20, I18n.getInstance().translateKey(buttonTranslationKey)));
+        }
 
         top = TOP_SPACING;
         bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
@@ -122,39 +132,33 @@ public class GuiPaged
         }
     }
 
-    @Override
-    public void onClosed() {
-        super.onClosed();
-        mc.gameSettings.saveOptions();
-    }
-
-    private void scrollOptions(float amount) {
+    private void scrollRightPanel(float amount) {
         if(amount == 0.0f) return;
 
         rightScrollAmount += amount;
-        onScrollOptions();
+        onScrollRightPanel();
     }
 
-    private void onScrollOptions() {
-        int totalPageHeight = getTotalPageHeight();
-        if (rightScrollAmount < 0 || rightScrollRegionHeight > totalPageHeight) rightScrollAmount = 0;
-        else if (rightScrollAmount > totalPageHeight - rightScrollRegionHeight) rightScrollAmount = totalPageHeight - rightScrollRegionHeight;
+    private void onScrollRightPanel() {
+        int totalRightPanelHeight = getTotalRightPanelHeight();
+        if (rightScrollAmount < 0 || rightScrollRegionHeight > totalRightPanelHeight) rightScrollAmount = 0;
+        else if (rightScrollAmount > totalRightPanelHeight - rightScrollRegionHeight) rightScrollAmount = totalRightPanelHeight - rightScrollRegionHeight;
     }
 
-    private void scrollPagesList(float amount) {
+    private void scrollLeftPanel(float amount) {
         if(amount == 0.0f) return;
 
         leftScrollAmount += amount;
-        onScrollPagesList();
+        onScrollLeftPanel();
     }
 
-    private void onScrollPagesList() {
-        int totalPagesListHeight = getTotalPagesListHeight();
-        if (leftScrollAmount < 0 || leftScrollRegionHeight > totalPagesListHeight) leftScrollAmount = 0;
-        else if (leftScrollAmount > totalPagesListHeight - leftScrollRegionHeight) leftScrollAmount = totalPagesListHeight - leftScrollRegionHeight;
+    private void onScrollLeftPanel() {
+        int totalLeftPanelHeight = getTotalLeftPanelHeight();
+        if (leftScrollAmount < 0 || leftScrollRegionHeight > totalLeftPanelHeight) leftScrollAmount = 0;
+        else if (leftScrollAmount > totalLeftPanelHeight - leftScrollRegionHeight) leftScrollAmount = totalLeftPanelHeight - leftScrollRegionHeight;
     }
 
-    private int getTotalPageHeight()
+    private int getTotalRightPanelHeight()
     {
         int totalPageHeight = 0;
         for (PageComponent component : selectedPage.getComponents())
@@ -164,7 +168,7 @@ public class GuiPaged
         return totalPageHeight;
     }
 
-    private int getTotalPagesListHeight() {
+    private int getTotalLeftPanelHeight() {
         return PAGE_BUTTON_HEIGHT * pageRegistry.getPages().size();
     }
 
@@ -173,18 +177,18 @@ public class GuiPaged
     {
         if (mouseX > leftWidth + SEPARATOR_WIDTH + PADDING && mouseX < width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
-                scrollOptions(Mouse.getDWheel() * -1.0f);
+                scrollRightPanel(Mouse.getDWheel() * -1.0f);
             } else {
-                scrollOptions(Mouse.getDWheel() / -5.0f);
+                scrollRightPanel(Mouse.getDWheel() / -5.0f);
             }
-            onScrollOptions();
+            onScrollRightPanel();
         } else if (mouseX >= 0 && mouseX <= leftWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
-                scrollPagesList(Mouse.getDWheel() * -1.0f);
+                scrollLeftPanel(Mouse.getDWheel() * -1.0f);
             } else {
-                scrollPagesList(Mouse.getDWheel() / -5.0f);
+                scrollLeftPanel(Mouse.getDWheel() / -5.0f);
             }
-            onScrollPagesList();
+            onScrollLeftPanel();
         }
 
         leftWidth = (int)(width * 0.25f);
@@ -204,7 +208,7 @@ public class GuiPaged
         Scissor.disable();
 
         Scissor.enable(0, top, leftWidth, bottom - top);
-        int pagesListHeight = getTotalPagesListHeight();
+        int pagesListHeight = getTotalLeftPanelHeight();
         int pagesListY = top - (int) leftScrollAmount;
         if (pagesListHeight < bottom - top) {
             pagesListY = top + (bottom - top - pagesListHeight) / 2;
@@ -254,17 +258,16 @@ public class GuiPaged
 
         overlayBackground(leftWidth, leftWidth + SEPARATOR_WIDTH, top, bottom);
 
-        String titleLanguageKey = "gui.options.title";
-        drawStringCentered(fontRenderer, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
+        drawStringCentered(fontRenderer, i18n.translateKey(titleTranslationKey), width / 2, 5, 0xffffff);
 
-        drawOptionsScrollBar(mouseX, mouseY);
-        drawPagesListScrollBar(mouseX, mouseY);
+        drawRightPanelScrollBar(mouseX, mouseY);
+        drawLeftPanelScrollBar(mouseX, mouseY);
 
         super.drawScreen(mouseX, mouseY, renderPartialTicks);
     }
 
-    protected void drawOptionsScrollBar(int mouseX, int mouseY) {
-        float totalPageHeight = getTotalPageHeight();
+    protected void drawRightPanelScrollBar(int mouseX, int mouseY) {
+        float totalPageHeight = getTotalRightPanelHeight();
         float scrollBarHeightPercent = rightScrollRegionHeight / totalPageHeight;
 
         if(scrollBarHeightPercent > 1.0f) return;
@@ -301,15 +304,15 @@ public class GuiPaged
                     oldRightScrollAmount = rightScrollAmount;
                 }
                 rightScrollAmount = oldRightScrollAmount + (clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
-                onScrollOptions();
+                onScrollRightPanel();
             }
         }else {
             oldRightScrollAmount = null;
         }
     }
 
-    protected void drawPagesListScrollBar(int mouseX, int mouseY) {
-        float totalPagesListHeight = getTotalPagesListHeight();
+    protected void drawLeftPanelScrollBar(int mouseX, int mouseY) {
+        float totalPagesListHeight = getTotalLeftPanelHeight();
         float scrollBarHeightPercent = leftScrollRegionHeight / totalPagesListHeight;
 
         if(scrollBarHeightPercent > 1.0f) return;
@@ -346,7 +349,7 @@ public class GuiPaged
                     oldLeftScrollAmount = leftScrollAmount;
                 }
                 leftScrollAmount = oldLeftScrollAmount + (clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
-                onScrollOptions();
+                onScrollRightPanel();
             }
         }else {
             oldLeftScrollAmount = null;
@@ -373,7 +376,7 @@ public class GuiPaged
                 componentY += component.getHeight();
             }
         } else if (mouseX >= 0 && mouseX <= leftWidth && mouseY >= top && mouseY <= bottom) {
-            int pagesListHeight = getTotalPagesListHeight();
+            int pagesListHeight = getTotalLeftPanelHeight();
             int pagesListY = top - (int) leftScrollAmount;
             if (pagesListHeight < bottom - top) {
                 pagesListY = top + (bottom - top - pagesListHeight) / 2;
diff --git a/src/main/java/net/minecraft/client/gui/paged/OnValueChangedCallback.java b/src/main/java/net/minecraft/client/gui/paged/OnValueChangedCallback.java
new file mode 100644
index 000000000..2fe278b70
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/paged/OnValueChangedCallback.java
@@ -0,0 +1,5 @@
+package net.minecraft.client.gui.paged;
+
+public interface OnValueChangedCallback<T> {
+    void onValueChanged(CallbackComponent<T> component, T oldValue, T newValue);
+}
diff --git a/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java b/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
index c38e82dcf..5ce0ad5c7 100644
--- a/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
+++ b/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
@@ -7,10 +7,12 @@ import java.util.List;
 public class PageRegistry {
     private final List<Page> pages = new ArrayList<>();
 
-    public void register(Page page) {
+    public Page register(Page page) {
         if (!pages.contains(page)) {
             pages.add(page);
         }
+
+        return page;
     }
 
     public int getPageIndex(Page page) {
diff --git a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
index 18e1bfc9c..abda90ff7 100644
--- a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
@@ -15,6 +15,7 @@ import java.util.Random;
 import com.b100.utils.StringUtils;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.fx.EntityPickupFX;
 import net.minecraft.client.entity.player.EntityClientPlayerMP;
 import net.minecraft.client.entity.player.EntityOtherPlayerMP;
 import net.minecraft.client.entity.player.EntityPlayerSP;
@@ -50,7 +51,6 @@ import net.minecraft.core.entity.EntityLightningBolt;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.entity.EntityTNT;
-import net.minecraft.client.entity.fx.EntityPickupFX;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.entity.projectile.EntityArrow;
 import net.minecraft.core.entity.projectile.EntityArrowGolden;
@@ -69,7 +69,67 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.PlayerProfile;
 import net.minecraft.core.net.handler.NetHandler;
-import net.minecraft.core.net.packet.*;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet100OpenWindow;
+import net.minecraft.core.net.packet.Packet101CloseWindow;
+import net.minecraft.core.net.packet.Packet103SetSlot;
+import net.minecraft.core.net.packet.Packet104WindowItems;
+import net.minecraft.core.net.packet.Packet105UpdateProgressbar;
+import net.minecraft.core.net.packet.Packet106Transaction;
+import net.minecraft.core.net.packet.Packet10Flying;
+import net.minecraft.core.net.packet.Packet131MapData;
+import net.minecraft.core.net.packet.Packet132SetMobSpawner;
+import net.minecraft.core.net.packet.Packet136SendKey;
+import net.minecraft.core.net.packet.Packet138PlayerList;
+import net.minecraft.core.net.packet.Packet140TileEntityData;
+import net.minecraft.core.net.packet.Packet142OpenFlagWindow;
+import net.minecraft.core.net.packet.Packet143PhotoMode;
+import net.minecraft.core.net.packet.Packet16BlockItemSwitch;
+import net.minecraft.core.net.packet.Packet17Sleep;
+import net.minecraft.core.net.packet.Packet18Animation;
+import net.minecraft.core.net.packet.Packet1Login;
+import net.minecraft.core.net.packet.Packet200Statistic;
+import net.minecraft.core.net.packet.Packet201Ids;
+import net.minecraft.core.net.packet.Packet20NamedEntitySpawn;
+import net.minecraft.core.net.packet.Packet21PickupSpawn;
+import net.minecraft.core.net.packet.Packet22Collect;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.net.packet.Packet24MobSpawn;
+import net.minecraft.core.net.packet.Packet250CustomPayload;
+import net.minecraft.core.net.packet.Packet255KickDisconnect;
+import net.minecraft.core.net.packet.Packet25EntityPainting;
+import net.minecraft.core.net.packet.Packet28EntityVelocity;
+import net.minecraft.core.net.packet.Packet29DestroyEntity;
+import net.minecraft.core.net.packet.Packet2Handshake;
+import net.minecraft.core.net.packet.Packet30Entity;
+import net.minecraft.core.net.packet.Packet34EntityTeleport;
+import net.minecraft.core.net.packet.Packet35EntityNickname;
+import net.minecraft.core.net.packet.Packet38EntityStatus;
+import net.minecraft.core.net.packet.Packet39AttachEntity;
+import net.minecraft.core.net.packet.Packet3Chat;
+import net.minecraft.core.net.packet.Packet40EntityMetadata;
+import net.minecraft.core.net.packet.Packet41EntityPlayerGamemode;
+import net.minecraft.core.net.packet.Packet42EntityTagData;
+import net.minecraft.core.net.packet.Packet4UpdateTime;
+import net.minecraft.core.net.packet.Packet50PreChunk;
+import net.minecraft.core.net.packet.Packet51MapChunk;
+import net.minecraft.core.net.packet.Packet52MultiBlockChange;
+import net.minecraft.core.net.packet.Packet53BlockChange;
+import net.minecraft.core.net.packet.Packet54PlayNoteBlock;
+import net.minecraft.core.net.packet.Packet5PlayerInventory;
+import net.minecraft.core.net.packet.Packet60Explosion;
+import net.minecraft.core.net.packet.Packet61PlaySoundEffect;
+import net.minecraft.core.net.packet.Packet62PlaySoundDirect;
+import net.minecraft.core.net.packet.Packet63SpawnParticleEffect;
+import net.minecraft.core.net.packet.Packet6SpawnPosition;
+import net.minecraft.core.net.packet.Packet70Bed;
+import net.minecraft.core.net.packet.Packet71Weather;
+import net.minecraft.core.net.packet.Packet72UpdatePlayerProfile;
+import net.minecraft.core.net.packet.Packet73WeatherStatus;
+import net.minecraft.core.net.packet.Packet74GameRule;
+import net.minecraft.core.net.packet.Packet75RecipeSync;
+import net.minecraft.core.net.packet.Packet8UpdateHealth;
+import net.minecraft.core.net.packet.Packet9Respawn;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.Container;
 import net.minecraft.core.player.inventory.InventoryBasic;
@@ -632,25 +692,26 @@ public class NetClientHandler extends NetHandler
         }
     }
 
-    @Override
-    public void handleChat(Packet3Chat packet3chat)
-    {
-        if (packet3chat.encrypted)
-        {
-            try
-            {
-                mc.ingameGUI.addChatMessage(AES.decrypt(packet3chat.message, AES.clientKeyChain));
-            }
-            catch (Exception e)
-            {
-                throw new RuntimeException(e);
-            }
-        }
-        else
-        {
-            mc.ingameGUI.addChatMessage(packet3chat.message);
-        }
-    }
+	@Override
+	public void handleChat(Packet3Chat packet) {
+		String message;
+		if(packet.encrypted) {
+			try {
+				message = AES.decrypt(packet.message, AES.clientKeyChain);
+			}catch (Exception e) {
+				throw new RuntimeException(Packet3Chat.ENCRYPTION_ERROR_MESSAGE, e);
+			}
+		}else {
+			message = packet.message;
+		}
+		
+		int type = packet.type;
+		if(type == 1) {
+			mc.ingameGUI.guiHeldItemTooltip.setString(message);
+		}else {
+			mc.ingameGUI.addChatMessage(message);
+		}
+	}
 
     public void handlePlayerJoin(Packet3Chat packet3chat)
     {
@@ -1097,7 +1158,7 @@ public class NetClientHandler extends NetHandler
         int i = packet70bed.field_25019_b;
         if (i >= 0 && i < Packet70Bed.field_25020_a.length && Packet70Bed.field_25020_a[i] != null)
         {
-            mc.thePlayer.addChatMessage(Packet70Bed.field_25020_a[i]);
+            mc.thePlayer.sendTranslatedChatMessage(Packet70Bed.field_25020_a[i]);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/ChunkRenderer.java b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
index b6a6be774..e2e0a9e87 100644
--- a/src/main/java/net/minecraft/client/render/ChunkRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
@@ -96,7 +96,7 @@ public class ChunkRenderer
         specialTileEntities.clear();
         int cacheRadius = 1;
         ChunkCache chunkcache = new ChunkCache(worldObj, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
-        RenderBlocks renderblocks = new RenderBlocks(worldObj, chunkcache);
+        RenderBlocks renderblocks = new RenderBlocks(chunkcache);
         BlockModel.setRenderBlocks(renderblocks);
         int renderPass = 0;
         do
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 8f50e409e..fb43cd95c 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -1,6 +1,10 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModelStairs;
+import net.minecraft.client.render.block.model.BlockModelStandard;
+import net.minecraft.client.render.item.model.ItemModel;
+import net.minecraft.client.render.item.model.ItemModelStandard;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.block.ItemBlock;
 import org.lwjgl.opengl.GL11;
@@ -133,8 +137,10 @@ public class ItemRenderer
             Block block = Block.blocksList[id];
             BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
 			if(mc.theWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
+                System.out.println(block.getKey());
 				renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
 			} else {
+                id = 0;
 				for (int i = 0; i < 8; i++) {
 					float x0 = ((float) ((i >> 0) % 2) - 0.5F) * mc.thePlayer.bbWidth * 0.9F;
 					float y0 = ((float) ((i >> 1) % 2) - 0.5F) * mc.thePlayer.bbHeight * 0.2F;
@@ -147,13 +153,15 @@ public class ItemRenderer
 					if(mc.theWorld.isBlockNormalCube(x1, y1, z1)) {
 						id = mc.theWorld.getBlockId(x1, y1, z1);
                         meta = mc.theWorld.getBlockMetadata(x1, y1, z1);
+                        break;
 					}
 				}
+                if(Block.blocksList[id] != null) {
+                    model = BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[id]);
+                    renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
+                }
 			}
-			
-			if(Block.blocksList[id] != null) {
-				renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
-			}
+
 		}
 		if(mc.thePlayer.isUnderLiquid(Material.water)) {
 			int k = mc.renderEngine.getTexture("/misc/water.png");
diff --git a/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index e2cc3b93d..ff2cc31ab 100644
--- a/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -82,25 +82,25 @@ public class PostProcessingManager
         }
 
         // Perform season effects
-        float seasonProgress = mc.theWorld.seasonManager.getSeasonProgress(); // Ragnes from 0.0 to 1.0
+        float seasonProgress = mc.theWorld.getSeasonManager().getSeasonProgress(); // Ranges from 0.0 to 1.0
         seasonProgress = (seasonProgress * 2) - 1f; // Ranges from -1.0 to 1.0
         seasonProgress = Math.abs(seasonProgress); // Ranges from 1.0 to 0.0 to 1.0
         seasonProgress = -seasonProgress + 1.0f; // Ranges from 0.0 to 1.0 to 0.0
-        if (mc.theWorld.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_SPRING)
+        if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING)
         {
             saturation += 0.1f * seasonProgress * surfaceness;
         }
-        else if (mc.theWorld.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_SUMMER)
+        else if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER)
         {
             rMod += 0.1f * seasonProgress * surfaceness;
             gMod += 0.1f * seasonProgress * surfaceness;
         }
-        else if (mc.theWorld.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_FALL)
+        else if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)
         {
             contrast -= 0.1f * seasonProgress * surfaceness;
             rMod += 0.1f * seasonProgress * surfaceness;
         }
-        else if (mc.theWorld.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER)
+        else if (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER)
         {
             contrast -= 0.1f * seasonProgress * surfaceness;
             bMod += 0.1f * seasonProgress * surfaceness;
@@ -136,7 +136,7 @@ public class PostProcessingManager
                 saturation += -0.2f * intensity * surfaceness;
                 brightness += -0.1f * intensity * surfaceness;
             }
-            else if (activeWeather == Weather.overworldFog)
+            else if (activeWeather == Weather.overworldFog && mc.gameSettings.fog.value)
             {
                 saturation += -0.4f * intensity * surfaceness;
                 contrast += -0.25f * intensity * surfaceness;
@@ -156,7 +156,7 @@ public class PostProcessingManager
         }
 
         // Perform heatwave effects
-        if (mc.theWorld.dimension == Dimension.overworld && (mc.theWorld.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_SUMMER || mc.theWorld.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_FALL))
+        if (mc.theWorld.dimension == Dimension.overworld && (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL))
         {
             if (temperature >= 0.85 && humidity <= 0.15)
             {
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 5fbd182f5..e53048021 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -22,7 +22,7 @@ import net.minecraft.core.world.WorldSource;
 public class RenderBlocks
 {
 
-    public RenderBlocks(World world, WorldSource worldSource)
+    public RenderBlocks(WorldSource worldSource)
     {
         overrideBlockTexture = null;
         flipTexture = false;
@@ -37,7 +37,6 @@ public class RenderBlocks
         field_22352_G = 1;
         blockAccess = worldSource;
         renderBitMask = 0;
-        this.world = world;
         this.mc = Minecraft.getMinecraft(this);
     }
 
@@ -128,7 +127,7 @@ public class RenderBlocks
 
     public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, Block block, int x, int y, int z)
     {
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(world, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(blockAccess, x, y, z);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
@@ -218,7 +217,7 @@ public class RenderBlocks
         if (tex == null || ((renderBitMask >> side) & 1) != 0) return false;
 
         boolean rendered = false;
-        block.setBlockBoundsBasedOnSide(world, x, y, z, Side.getSideById(side));
+        block.setBlockBoundsBasedOnSide(this.blockAccess, x, y, z, Side.getSideById(side));
         if (this.renderAllFaces || blockModel.shouldSideBeRendered(this.blockAccess, x+dirX, y+dirY, z+dirZ, side, meta)) {
 
             setupLighting(r, g, b, side, meta,
@@ -891,7 +890,6 @@ public class RenderBlocks
     }
     public WorldSource blockAccess;
     private final Minecraft mc;
-    public World world;
     public IconCoordinate overrideBlockTexture;
     public boolean flipTexture;
     public boolean renderAllFaces;
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 78f5eaf18..b3d254975 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -227,7 +227,7 @@ public class RenderGlobal
         EntityRenderDispatcher.instance.unloadEntityRenderers();
         EntityRenderDispatcher.instance.setWorld(world);
         worldObj = world;
-        globalRenderBlocks = new RenderBlocks(world, world);
+        globalRenderBlocks = new RenderBlocks(world);
         auroraBrightness = 0.0f;
         targetAuroraBrightness = Float.NaN;
         if(world != null)
@@ -328,7 +328,7 @@ public class RenderGlobal
         double cameraYaw = camera.getYRot(partialTick);
         float temperature = (float)worldObj.getBlockTemperature((int)cameraX, (int)cameraZ);
         float mult = 0.0f;
-        if (temperature <= 0.4f || worldObj.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS)
+        if (temperature <= 0.4f || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS)
         {
             // temperature from 0.0f to 0.4f
             temperature /= 0.4f;
@@ -339,7 +339,7 @@ public class RenderGlobal
         }
 
         float altitude = (float)worldObj.getWorldType().getYPercentage((int)cameraY);
-        if ((temperature <= 0.6f || worldObj.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER || worldObj.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && altitude >= 0.8f)
+        if ((temperature <= 0.6f || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && altitude >= 0.8f)
         {
             // altitude from 0.8f to 1.0f
             altitude -= 0.8f;
@@ -899,6 +899,10 @@ public class RenderGlobal
         GL11.glBlendFunc(770, 1);
         GL11.glPushMatrix();
         float f6 = 1.0F - (worldObj.getCurrentWeather() != null && worldObj.getCurrentWeather() != Weather.overworldClear ? (worldObj.weatherManager.getWeatherIntensity() * worldObj.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
+        if (!mc.gameSettings.fog.value && worldObj.getCurrentWeather() == Weather.overworldFog)
+        {
+            f6 = 1f;
+        }
         float f9 = 0.0F;
         float f11 = 0.0F;
         float f13 = 0.0F;
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index b33707119..3af796da9 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -668,7 +668,15 @@ public class WorldRenderer
         Debug.change("entities");
         GL11.glShadeModel(7424 /*GL_FLAT*/);
         Lighting.enableLight();
+        if (!mc.gameSettings.fog.value)
+        {
+            GL11.glDisable(GL11.GL_FOG);
+        }
         renderGlobal.renderEntities(mc.activeCamera, partialTick);
+        if (!mc.gameSettings.fog.value)
+        {
+            GL11.glEnable(GL11.GL_FOG);
+        }
         
         Debug.change("particles");
         effectRenderer.renderParticlesAtOrigin(partialTick);
@@ -712,7 +720,15 @@ public class WorldRenderer
             GL11.glColorMask(true, true, true, true);
             if(i1 > 0)
             {
+                if (!mc.gameSettings.fog.value)
+                {
+                    GL11.glDisable(GL11.GL_FOG);
+                }
                 renderGlobal.callAllDisplayLists(1, partialTick);
+                if (!mc.gameSettings.fog.value)
+                {
+                    GL11.glEnable(GL11.GL_FOG);
+                }
             }
             GL11.glShadeModel(GL11.GL_FLAT);
         }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColor.java b/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
index 565077c26..b9036f77c 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColor.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.block.color;
 
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public abstract class BlockColor
 {
     public abstract int getFallbackColor(int meta);
 
-    public abstract int getWorldColor(World world, int x, int y, int z);
+    public abstract int getWorldColor(WorldSource world, int x, int y, int z);
 }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
index bfd8d518c..ce2dd08ae 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.block.color;
 
-import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockColorDefault
     extends BlockColor
@@ -12,7 +12,7 @@ public class BlockColorDefault
     }
 
     @Override
-    public int getWorldColor(World world, int x, int y, int z)
+    public int getWorldColor(WorldSource world, int x, int y, int z)
     {
         return 0xFFFFFF;
     }
